import { Box, Connection, CoordinateExtent, Dimensions, Edge, EdgeMarkerType, Elements, FlowElements, FlowExportObject, State, FlowStore, GraphEdge, GraphNode, Node, Rect, Transform, XYPosition, XYZPosition, Getters } from "../types";
export declare const isInputDOMNode: (e: KeyboardEvent | MouseEvent) => boolean;
export declare const getDimensions: (node: HTMLElement) => Dimensions;
export declare const clamp: (val: number, min?: number, max?: number) => number;
export declare const clampPosition: (position: XYPosition, extent: CoordinateExtent) => XYPosition;
export declare const getHostForElement: (element: HTMLElement) => Document;
export declare const isEdge: (element: Node | Edge | Connection) => element is Edge<any>;
export declare const isGraphEdge: (element: any) => element is GraphEdge<any, any>;
export declare const isNode: (element: Node | Edge | Connection) => element is Node<any>;
export declare const isGraphNode: (element: Node | Edge | Connection) => element is GraphNode<any>;
export declare const parseNode: (node: Node, nodeExtent: CoordinateExtent, defaults?: Partial<GraphNode<any>> | undefined) => GraphNode;
export declare const parseEdge: (edge: Edge, defaults?: Partial<GraphEdge<any, any>> | undefined) => GraphEdge;
export declare const getOutgoers: (node: GraphNode, elements: Elements<any, any>) => (Node<any> | Edge<any>)[];
export declare const getIncomers: (node: GraphNode, elements: Elements<any, any>) => (Node<any> | Edge<any>)[];
export declare const getEdgeId: ({ source, sourceHandle, target, targetHandle }: Connection) => string;
export declare const connectionExists: (edge: Edge, elements: Elements<any, any>) => boolean;
export declare const addEdge: (edgeParams: Edge | Connection, elements: Elements<any, any>) => Elements<any, any>;
export declare const updateEdge: (oldEdge: Edge, newConnection: Connection, elements: Elements<any, any>) => Elements<any, any>;
export declare const pointToRendererPoint: ({ x, y }: XYPosition, [tx, ty, tScale]: Transform, snapToGrid: boolean, [snapX, snapY]: [number, number]) => XYPosition;
export declare const onLoadProject: (currentStore: FlowStore) => (position: XYPosition) => XYPosition;
export declare const rectToBox: ({ x, y, width, height }: Rect) => Box;
export declare const boxToRect: ({ x, y, x2, y2 }: Box) => Rect;
export declare const getBoundsofRects: (rect1: Rect, rect2: Rect) => Rect;
export declare const getRectOfNodes: (nodes: GraphNode[]) => Rect;
export declare const graphPosToZoomedPos: ({ x, y }: XYPosition, [tx, ty, tScale]: Transform) => XYPosition;
export declare const getNodesInside: (nodes: GraphNode[], rect: Rect, [tx, ty, tScale]?: Transform, partially?: boolean) => GraphNode<any>[];
export declare const getConnectedEdges: (nodes: GraphNode[], edges: GraphEdge[]) => GraphEdge<any, any>[];
export declare const onLoadGetNodes: (store: FlowStore) => () => GraphNode[];
export declare const onLoadGetEdges: (store: FlowStore) => () => GraphEdge[];
export declare const onLoadGetElements: (store: FlowStore) => () => FlowElements<any, any>;
export declare const onLoadToObject: (store: State) => () => FlowExportObject;
export declare const getTransformForBounds: (bounds: Rect, width: number, height: number, minZoom: number, maxZoom: number, padding?: number, offset?: {
    x?: number;
    y?: number;
}) => Transform;
export declare const getXYZPos: (parentNode: GraphNode, computedPosition: XYZPosition) => XYZPosition;
export declare const isParentSelected: (node: GraphNode, getNode: Getters['getNode']) => boolean;
export declare const getMarkerId: (marker: EdgeMarkerType | undefined) => string;
